**Chapter 4: Multilevel Model with Dichotomous Outcomes (ch4data1.sav, ch4data2.sav)

**The Unconditional (Null) Model
**Model 1.1: Tables 4.2, 4.3, 4.4 (ch4data1.sav)

*Generalized Linear Mixed Models. 
GENLINMIXED
  /DATA_STRUCTURE SUBJECTS=schcode
  /FIELDS TARGET=readprof TRIALS=NONE OFFSET=NONE
  /TARGET_OPTIONS DISTRIBUTION=BINOMIAL LINK=LOGIT
  /FIXED USE_INTERCEPT=TRUE
  /RANDOM USE_INTERCEPT=TRUE SUBJECTS=schcode COVARIANCE_TYPE=VARIANCE_COMPONENTS 
  /BUILD_OPTIONS TARGET_CATEGORY_ORDER=DESCENDING INPUTS_CATEGORY_ORDER=DESCENDING 
    MAX_ITERATIONS=100 CONFIDENCE_LEVEL=95 DF_METHOD=RESIDUAL COVB=ROBUST
  /EMMEANS_OPTIONS SCALE=ORIGINAL PADJUST=LSD.


**Defining the Within-School Variables
**Model 1.2: Tables 4.5, 4.6, 4.7, 4.8 (ch4data1.sav)

*Generalized Linear Mixed Models. 
GENLINMIXED
  /DATA_STRUCTURE SUBJECTS=schcode
  /FIELDS TARGET=readprof TRIALS=NONE OFFSET=NONE
  /TARGET_OPTIONS DISTRIBUTION=BINOMIAL LINK=LOGIT
  /FIXED  EFFECTS=female lowses minor USE_INTERCEPT=TRUE
  /RANDOM USE_INTERCEPT=TRUE SUBJECTS=schcode COVARIANCE_TYPE=VARIANCE_COMPONENTS 
  /BUILD_OPTIONS TARGET_CATEGORY_ORDER=DESCENDING INPUTS_CATEGORY_ORDER=DESCENDING 
    MAX_ITERATIONS=100 CONFIDENCE_LEVEL=95 DF_METHOD=RESIDUAL COVB=ROBUST
  /EMMEANS_OPTIONS SCALE=ORIGINAL PADJUST=LSD.


**Examining Whether a Level-1 Slope Varies Between Schools
**Model 1.3: Table 4.9 (ch4data1.sav)

*Generalized Linear Mixed Models. 
GENLINMIXED
  /DATA_STRUCTURE SUBJECTS=schcode
  /FIELDS TARGET=readprof TRIALS=NONE OFFSET=NONE
  /TARGET_OPTIONS DISTRIBUTION=BINOMIAL LINK=LOGIT
  /FIXED  EFFECTS=female lowses minor USE_INTERCEPT=TRUE
  /RANDOM EFFECTS=minor USE_INTERCEPT=TRUE SUBJECTS=schcode COVARIANCE_TYPE=VARIANCE_COMPONENTS 
  /BUILD_OPTIONS TARGET_CATEGORY_ORDER=DESCENDING INPUTS_CATEGORY_ORDER=DESCENDING 
    MAX_ITERATIONS=100 CONFIDENCE_LEVEL=95 DF_METHOD=RESIDUAL COVB=ROBUST
  /EMMEANS_OPTIONS SCALE=ORIGINAL PADJUST=LSD.


**Adding Level-2 Predictors to Explain Variability in Intercepts 
**Model 1.4: Tables 4.10, 4.11, 4.12 (ch4data1.sav)

*Generalized Linear Mixed Models. 
GENLINMIXED
  /DATA_STRUCTURE SUBJECTS=schcode
  /FIELDS TARGET=readprof TRIALS=NONE OFFSET=NONE
  /TARGET_OPTIONS DISTRIBUTION=BINOMIAL LINK=LOGIT
  /FIXED  EFFECTS=schcomp smallsch female lowses minor USE_INTERCEPT=TRUE
  /RANDOM EFFECTS=minor USE_INTERCEPT=TRUE SUBJECTS=schcode COVARIANCE_TYPE=VARIANCE_COMPONENTS 
  /BUILD_OPTIONS TARGET_CATEGORY_ORDER=DESCENDING INPUTS_CATEGORY_ORDER=DESCENDING 
    MAX_ITERATIONS=100 CONFIDENCE_LEVEL=95 DF_METHOD=RESIDUAL COVB=ROBUST
  /EMMEANS_OPTIONS SCALE=ORIGINAL PADJUST=LSD.


**Adding Level-2 Variables to Explain Variation in Level-1 Slopes (Cross-Level Interaction)
**Model 1.5: Tables 4.13, 4.14 (ch4data1.sav)

*Generalized Linear Mixed Models. 
GENLINMIXED
  /DATA_STRUCTURE SUBJECTS=schcode
  /FIELDS TARGET=readprof TRIALS=NONE OFFSET=NONE
  /TARGET_OPTIONS DISTRIBUTION=BINOMIAL LINK=LOGIT
  /FIXED  EFFECTS=schcomp smallsch female lowses minor minor*schcomp minor*smallsch 
    USE_INTERCEPT=TRUE
  /RANDOM EFFECTS=minor USE_INTERCEPT=TRUE SUBJECTS=schcode COVARIANCE_TYPE=VARIANCE_COMPONENTS 
  /BUILD_OPTIONS TARGET_CATEGORY_ORDER=DESCENDING INPUTS_CATEGORY_ORDER=DESCENDING 
    MAX_ITERATIONS=100 CONFIDENCE_LEVEL=95 DF_METHOD=RESIDUAL COVB=ROBUST
  /EMMEANS_OPTIONS SCALE=ORIGINAL PADJUST=LSD.


**Estimating Means
**Model based on Eq. 4.22: Tables 4.16, 4.17 (ch4data1.sav)

*Generalized Linear Mixed Models. 
GENLINMIXED
  /DATA_STRUCTURE SUBJECTS=schcode
  /FIELDS TARGET=readprof TRIALS=NONE OFFSET=NONE
  /TARGET_OPTIONS DISTRIBUTION=BINOMIAL LINK=LOGIT
  /FIXED  EFFECTS=lowses minor lowses*minor USE_INTERCEPT=TRUE
  /RANDOM EFFECTS=minor USE_INTERCEPT=TRUE SUBJECTS=schcode COVARIANCE_TYPE=VARIANCE_COMPONENTS 
  /BUILD_OPTIONS TARGET_CATEGORY_ORDER=DESCENDING INPUTS_CATEGORY_ORDER=DESCENDING 
    MAX_ITERATIONS=100 CONFIDENCE_LEVEL=95 DF_METHOD=RESIDUAL COVB=ROBUST
  /EMMEANS TABLES=lowses COMPARE=lowses CONTRAST=SIMPLE 
   /EMMEANS TABLES=minor COMPARE=minor CONTRAST=SIMPLE 
   /EMMEANS TABLES=lowses*minor COMPARE=lowses CONTRAST=SIMPLE 
  /EMMEANS_OPTIONS SCALE=ORIGINAL PADJUST=SEQBONFERRONI.

 
**Probit Link Function
**Model 1.6: Table 4.20 (ch4data1.sav)

*Generalized Linear Mixed Models. 
GENLINMIXED
  /DATA_STRUCTURE SUBJECTS=schcode
  /FIELDS TARGET=readprof TRIALS=NONE OFFSET=NONE
  /TARGET_OPTIONS DISTRIBUTION=BINOMIAL LINK=PROBIT
  /FIXED  EFFECTS=schcomp smallsch female lowses minor minor*schcomp minor*smallsch 
    USE_INTERCEPT=TRUE
  /RANDOM EFFECTS=minor USE_INTERCEPT=TRUE SUBJECTS=schcode COVARIANCE_TYPE=VARIANCE_COMPONENTS 
  /BUILD_OPTIONS TARGET_CATEGORY_ORDER=DESCENDING INPUTS_CATEGORY_ORDER=DESCENDING 
    MAX_ITERATIONS=100 CONFIDENCE_LEVEL=95 DF_METHOD=RESIDUAL COVB=ROBUST
  /EMMEANS_OPTIONS SCALE=ORIGINAL PADJUST=LSD.

**The Unconditional Model
**Model 2.1: Table 4.23 (ch4data2.sav)

*Generalized Linear Mixed Models. 
GENLINMIXED
  /DATA_STRUCTURE SUBJECTS=schcode*Rteachid
  /FIELDS TARGET=readprof TRIALS=NONE OFFSET=NONE
  /TARGET_OPTIONS DISTRIBUTION=BINOMIAL LINK=LOGIT
  /FIXED USE_INTERCEPT=TRUE
  /RANDOM USE_INTERCEPT=TRUE SUBJECTS=schcode COVARIANCE_TYPE=VARIANCE_COMPONENTS 
  /RANDOM USE_INTERCEPT=TRUE SUBJECTS=schcode*Rteachid COVARIANCE_TYPE=VARIANCE_COMPONENTS 
  /BUILD_OPTIONS TARGET_CATEGORY_ORDER=DESCENDING INPUTS_CATEGORY_ORDER=DESCENDING 
    MAX_ITERATIONS=100 CONFIDENCE_LEVEL=95 DF_METHOD=RESIDUAL COVB=ROBUST
  /EMMEANS_OPTIONS SCALE=ORIGINAL PADJUST=LSD.


**Defining the Three-Level Model
**Model 2.2: Tables 4.24, 4.25, 4.26 (ch4data2.sav)

*Generalized Linear Mixed Models. 
GENLINMIXED
  /DATA_STRUCTURE SUBJECTS=schcode*Rteachid
  /FIELDS TARGET=readprof TRIALS=NONE OFFSET=NONE
  /TARGET_OPTIONS DISTRIBUTION=BINOMIAL LINK=LOGIT
  /FIXED  EFFECTS=schcomp smallsch gmclasscomp gmclass_size zteacheff lowses female minor 
    USE_INTERCEPT=TRUE
  /RANDOM USE_INTERCEPT=TRUE SUBJECTS=schcode COVARIANCE_TYPE=VARIANCE_COMPONENTS 
  /RANDOM USE_INTERCEPT=TRUE SUBJECTS=schcode*Rteachid COVARIANCE_TYPE=VARIANCE_COMPONENTS 
  /BUILD_OPTIONS TARGET_CATEGORY_ORDER=DESCENDING INPUTS_CATEGORY_ORDER=DESCENDING 
    MAX_ITERATIONS=100 CONFIDENCE_LEVEL=95 DF_METHOD=RESIDUAL COVB=ROBUST
  /EMMEANS_OPTIONS SCALE=ORIGINAL PADJUST=LSD.
