**Chapter 5: Multilevel Models with a Categorical Repeated Measures Outcome (ch5data1.sav, ch5data1-ord.sav, ch5data2.sav)


**Model 1.1: Tables 5.2, 5.3, 5.4, 5.5, 5.6 (ch5data1.sav)
 
* Generalized Estimating Equations.
GENLIN readprof (REFERENCE=FIRST) WITH time
  /MODEL time INTERCEPT=YES
 DISTRIBUTION=BINOMIAL LINK=LOGIT
  /CRITERIA METHOD=FISHER(1) SCALE=1 MAXITERATIONS=100 MAXSTEPHALVING=5 PCONVERGE=1E-006(ABSOLUTE) 
    SINGULAR=1E-012 ANALYSISTYPE=3(WALD) CILEVEL=95 LIKELIHOOD=FULL
  /REPEATED SUBJECT=id WITHINSUBJECT=time SORT=YES CORRTYPE=EXCHANGEABLE ADJUSTCORR=YES COVB=ROBUST 
    MAXITERATIONS=100 PCONVERGE=1e-006(ABSOLUTE) UPDATECORR=1
  /MISSING CLASSMISSING=EXCLUDE
  /PRINT CPS DESCRIPTIVES MODELINFO FIT SOLUTION (EXPONENTIATED) CORB.

 
**Alternate Coding of the Time Variable 
**Model 1.2: Tables 5.9, 5.11, 5.12  (ch5data1-ord.sav)

* Generalized Estimating Equations.
GENLIN readprof (REFERENCE=FIRST) BY time (ORDER=DESCENDING)
  /MODEL time INTERCEPT=YES
 DISTRIBUTION=BINOMIAL LINK=LOGIT
  /CRITERIA METHOD=FISHER(1) SCALE=1 MAXITERATIONS=100 MAXSTEPHALVING=5 PCONVERGE=1E-006(ABSOLUTE) 
    SINGULAR=1E-012 ANALYSISTYPE=3(WALD) CILEVEL=95 LIKELIHOOD=FULL
  /REPEATED SUBJECT=id WITHINSUBJECT=time SORT=YES CORRTYPE=EXCHANGEABLE ADJUSTCORR=YES COVB=ROBUST 
    MAXITERATIONS=100 PCONVERGE=1e-006(ABSOLUTE) UPDATECORR=1
  /MISSING CLASSMISSING=EXCLUDE
  /PRINT CPS DESCRIPTIVES MODELINFO FIT SUMMARY SOLUTION (EXPONENTIATED) WORKINGCORR.


**Table 5.10  Correlations of Parameter Estimates (Recoded time Variable; ch5data1-ord.sav)

* Generalized Estimating Equations.
GENLIN readprof (REFERENCE=FIRST) WITH timeend
  /MODEL timeend INTERCEPT=YES
 DISTRIBUTION=BINOMIAL LINK=LOGIT
  /CRITERIA METHOD=FISHER(1) SCALE=1 MAXITERATIONS=100 MAXSTEPHALVING=5 PCONVERGE=1E-006(ABSOLUTE) 
    SINGULAR=1E-012 ANALYSISTYPE=3(WALD) CILEVEL=95 LIKELIHOOD=FULL
  /REPEATED SUBJECT=id WITHINSUBJECT=timeend SORT=YES CORRTYPE=EXCHANGEABLE ADJUSTCORR=YES 
    COVB=ROBUST MAXITERATIONS=100 PCONVERGE=1e-006(ABSOLUTE) UPDATECORR=1
  /MISSING CLASSMISSING=EXCLUDE
  /PRINT CPS DESCRIPTIVES MODELINFO FIT SUMMARY SOLUTION (EXPONENTIATED) CORB.


**Model 1.3: Table 5.13  (unstructured correlation matrix;  ch5data1.sav)

* Generalized Estimating Equations.
GENLIN readprof (REFERENCE=FIRST) WITH time
  /MODEL time INTERCEPT=YES
 DISTRIBUTION=BINOMIAL LINK=LOGIT
  /CRITERIA METHOD=FISHER(1) SCALE=1 MAXITERATIONS=100 MAXSTEPHALVING=5 PCONVERGE=1E-006(ABSOLUTE) 
    SINGULAR=1E-012 ANALYSISTYPE=3(WALD) CILEVEL=95 LIKELIHOOD=FULL
  /REPEATED SUBJECT=id WITHINSUBJECT=time SORT=YES CORRTYPE=UNSTRUCTURED ADJUSTCORR=YES COVB=ROBUST 
    MAXITERATIONS=100 PCONVERGE=1e-006(ABSOLUTE) UPDATECORR=1
  /MISSING CLASSMISSING=EXCLUDE
  /PRINT CPS DESCRIPTIVES MODELINFO FIT SUMMARY SOLUTION (EXPONENTIATED) WORKINGCORR.

 
**Adding a Predictor
**Model 1.4: Table 5.14  (ch5data1.sav)

* Generalized Estimating Equations.
GENLIN readprof (REFERENCE=FIRST) BY female (ORDER=DESCENDING) WITH time
  /MODEL female time INTERCEPT=YES
 DISTRIBUTION=BINOMIAL LINK=LOGIT
  /CRITERIA METHOD=FISHER(1) SCALE=1 MAXITERATIONS=100 MAXSTEPHALVING=5 PCONVERGE=1E-006(ABSOLUTE) 
    SINGULAR=1E-012 ANALYSISTYPE=3(WALD) CILEVEL=95 LIKELIHOOD=FULL
  /REPEATED SUBJECT=id WITHINSUBJECT=time SORT=YES CORRTYPE=EXCHANGEABLE ADJUSTCORR=YES COVB=ROBUST 
    MAXITERATIONS=100 PCONVERGE=1e-006(ABSOLUTE) UPDATECORR=1
  /MISSING CLASSMISSING=EXCLUDE
  /PRINT CPS DESCRIPTIVES MODELINFO FIT SUMMARY SOLUTION (EXPONENTIATED) WORKINGCORR.

**Alternative Model 1.4: Table 5.15 (time treated as ordinal; data5-1ord.sav)

* Generalized Estimating Equations.
GENLIN readprof (REFERENCE=FIRST) BY female time (ORDER=DESCENDING)
  /MODEL female time INTERCEPT=YES
 DISTRIBUTION=BINOMIAL LINK=LOGIT
  /CRITERIA METHOD=FISHER(1) SCALE=1 MAXITERATIONS=100 MAXSTEPHALVING=5 PCONVERGE=1E-006(ABSOLUTE) 
    SINGULAR=1E-012 ANALYSISTYPE=3(WALD) CILEVEL=95 LIKELIHOOD=FULL
  /REPEATED SUBJECT=id WITHINSUBJECT=time SORT=YES CORRTYPE=EXCHANGEABLE ADJUSTCORR=YES COVB=ROBUST 
    MAXITERATIONS=100 PCONVERGE=1e-006(ABSOLUTE) UPDATECORR=1
  /MISSING CLASSMISSING=EXCLUDE
  /PRINT CPS DESCRIPTIVES MODELINFO FIT SUMMARY SOLUTION (EXPONENTIATED).


**Adding an Interaction between Female and the Time Parameter 
**Model 1.5: Table 5.16  (ch5data1.sav)

* Generalized Estimating Equations.
GENLIN readprof (REFERENCE=FIRST) BY female (ORDER=DESCENDING) WITH time
  /MODEL female time female*time INTERCEPT=YES
 DISTRIBUTION=BINOMIAL LINK=LOGIT
  /CRITERIA METHOD=FISHER(1) SCALE=1 MAXITERATIONS=100 MAXSTEPHALVING=5 PCONVERGE=1E-006(ABSOLUTE) 
    SINGULAR=1E-012 ANALYSISTYPE=3(WALD) CILEVEL=95 LIKELIHOOD=FULL
  /REPEATED SUBJECT=id WITHINSUBJECT=time SORT=YES CORRTYPE=EXCHANGEABLE ADJUSTCORR=YES COVB=ROBUST 
    MAXITERATIONS=100 PCONVERGE=1e-006(ABSOLUTE) UPDATECORR=1
  /MISSING CLASSMISSING=EXCLUDE
  /PRINT CPS DESCRIPTIVES MODELINFO FIT SUMMARY SOLUTION (EXPONENTIATED) WORKINGCORR.

**Alternate Model 1.5: Table 5.17 (time variable is ordinal; ch5data1-ord.sav)

* Generalized Estimating Equations.
GENLIN readprof (REFERENCE=FIRST) BY female time (ORDER=DESCENDING)
  /MODEL female time female*time INTERCEPT=YES
 DISTRIBUTION=BINOMIAL LINK=LOGIT
  /CRITERIA METHOD=FISHER(1) SCALE=1 MAXITERATIONS=100 MAXSTEPHALVING=5 PCONVERGE=1E-006(ABSOLUTE) 
    SINGULAR=1E-012 ANALYSISTYPE=3(WALD) CILEVEL=95 LIKELIHOOD=FULL
  /REPEATED SUBJECT=id WITHINSUBJECT=time SORT=YES CORRTYPE=EXCHANGEABLE ADJUSTCORR=YES COVB=ROBUST 
    MAXITERATIONS=100 PCONVERGE=1e-006(ABSOLUTE) UPDATECORR=1
  /MISSING CLASSMISSING=EXCLUDE
  /PRINT CPS DESCRIPTIVES MODELINFO FIT SUMMARY SOLUTION (EXPONENTIATED) WORKINGCORR.

 
**Specifying a GEE Model within GENLIN MIXED
**Model 2.1: Tables 5.18, 5.19, 5.20  (ch5data1.sav)

*Generalized Linear Mixed Models. 
GENLINMIXED
  /DATA_STRUCTURE SUBJECTS=id REPEATED_MEASURES=time COVARIANCE_TYPE=COMPOUND_SYMMETRY
  /FIELDS TARGET=readprof TRIALS=NONE OFFSET=NONE
  /TARGET_OPTIONS DISTRIBUTION=BINOMIAL LINK=LOGIT
  /FIXED  EFFECTS=female time USE_INTERCEPT=TRUE
  /BUILD_OPTIONS TARGET_CATEGORY_ORDER=DESCENDING INPUTS_CATEGORY_ORDER=DESCENDING 
    MAX_ITERATIONS=100 CONFIDENCE_LEVEL=95 DF_METHOD=RESIDUAL COVB=ROBUST
  /EMMEANS_OPTIONS SCALE=ORIGINAL PADJUST=LSD.

**Examining a Random Intercept at the Between-Student Level  
**Model 2.2: Tables 5.21, 5.22, 5.23  (ch5data1.sav)

*Generalized Linear Mixed Models. 
GENLINMIXED
  /DATA_STRUCTURE SUBJECTS=id REPEATED_MEASURES=time COVARIANCE_TYPE=AR1
  /FIELDS TARGET=readprof TRIALS=NONE OFFSET=NONE
  /TARGET_OPTIONS DISTRIBUTION=BINOMIAL LINK=LOGIT
  /FIXED  EFFECTS=time USE_INTERCEPT=TRUE
  /RANDOM USE_INTERCEPT=TRUE SUBJECTS=id COVARIANCE_TYPE=VARIANCE_COMPONENTS 
  /BUILD_OPTIONS TARGET_CATEGORY_ORDER=DESCENDING INPUTS_CATEGORY_ORDER=DESCENDING 
    MAX_ITERATIONS=100 CONFIDENCE_LEVEL=95 DF_METHOD=RESIDUAL COVB=ROBUST
  /EMMEANS_OPTIONS SCALE=ORIGINAL PADJUST=LSD.


**What Variables Affect Differences in Proficiency Across Individuals?
**Model 2.3: Tables 5.24, 5.25, 5.26 (ch5data1.sav)

*Generalized Linear Mixed Models. 
GENLINMIXED
  /DATA_STRUCTURE SUBJECTS=id REPEATED_MEASURES=time COVARIANCE_TYPE=AR1
  /FIELDS TARGET=readprof TRIALS=NONE OFFSET=NONE
  /TARGET_OPTIONS DISTRIBUTION=BINOMIAL LINK=LOGIT
  /FIXED  EFFECTS=female lowses time female*time time*lowses USE_INTERCEPT=TRUE
  /RANDOM USE_INTERCEPT=TRUE SUBJECTS=id COVARIANCE_TYPE=VARIANCE_COMPONENTS 
  /BUILD_OPTIONS TARGET_CATEGORY_ORDER=DESCENDING INPUTS_CATEGORY_ORDER=DESCENDING 
    MAX_ITERATIONS=100 CONFIDENCE_LEVEL=95 DF_METHOD=RESIDUAL COVB=ROBUST
  /EMMEANS_OPTIONS SCALE=ORIGINAL PADJUST=LSD.

**Alternative Model (GEE Procedure): 2.3: Table 5.27  (ch5data1.sav)

* Generalized Estimating Equations.
GENLIN readprof (REFERENCE=FIRST) BY female lowses (ORDER=DESCENDING) WITH time
  /MODEL female lowses time female*time lowses*time INTERCEPT=YES
 DISTRIBUTION=BINOMIAL LINK=LOGIT
  /CRITERIA METHOD=FISHER(1) SCALE=1 MAXITERATIONS=100 MAXSTEPHALVING=5 PCONVERGE=1E-006(ABSOLUTE) 
    SINGULAR=1E-012 ANALYSISTYPE=3(WALD) CILEVEL=95 LIKELIHOOD=FULL
  /REPEATED SUBJECT=id WITHINSUBJECT=time1 SORT=YES CORRTYPE=EXCHANGEABLE ADJUSTCORR=YES 
    COVB=ROBUST MAXITERATIONS=100 PCONVERGE=1e-006(ABSOLUTE) UPDATECORR=1
  /MISSING CLASSMISSING=EXCLUDE
  /PRINT CPS DESCRIPTIVES MODELINFO FIT SUMMARY SOLUTION (EXPONENTIATED).
 
**The Beginning Model 
**Model 3.1: Tables 5.28, 5.29, 5.30  (ch5data1.sav)

*Generalized Linear Mixed Models. 
GENLINMIXED
  /DATA_STRUCTURE SUBJECTS=nschcode*Rid REPEATED_MEASURES=time COVARIANCE_TYPE=AR1
  /FIELDS TARGET=readprof TRIALS=NONE OFFSET=NONE
  /TARGET_OPTIONS DISTRIBUTION=BINOMIAL LINK=LOGIT
  /FIXED  EFFECTS=time USE_INTERCEPT=TRUE
  /RANDOM EFFECTS=time USE_INTERCEPT=TRUE SUBJECTS=nschcode COVARIANCE_TYPE=UNSTRUCTURED 
  /RANDOM USE_INTERCEPT=TRUE SUBJECTS=nschcode*Rid COVARIANCE_TYPE=VARIANCE_COMPONENTS 
  /BUILD_OPTIONS TARGET_CATEGORY_ORDER=DESCENDING INPUTS_CATEGORY_ORDER=DESCENDING 
    MAX_ITERATIONS=100 CONFIDENCE_LEVEL=95 DF_METHOD=RESIDUAL COVB=ROBUST
  /EMMEANS_OPTIONS SCALE=ORIGINAL PADJUST=LSD.

**Adding Student and School Predictors  
**Model 3.2: Tables 5.31, 5.32, 5.33  (ch5data1.sav)

*Generalized Linear Mixed Models. 
GENLINMIXED
  /DATA_STRUCTURE SUBJECTS=nschcode*Rid REPEATED_MEASURES=time COVARIANCE_TYPE=AR1
  /FIELDS TARGET=readprof TRIALS=NONE OFFSET=NONE
  /TARGET_OPTIONS DISTRIBUTION=BINOMIAL LINK=LOGIT
  /FIXED  EFFECTS=Zses_mean smallsch female lowses time Zses_mean*time time*smallsch female*time 
    time*lowses USE_INTERCEPT=TRUE
  /RANDOM EFFECTS=time USE_INTERCEPT=TRUE SUBJECTS=nschcode COVARIANCE_TYPE=UNSTRUCTURED 
  /RANDOM USE_INTERCEPT=TRUE SUBJECTS=nschcode*Rid COVARIANCE_TYPE=VARIANCE_COMPONENTS 
  /BUILD_OPTIONS TARGET_CATEGORY_ORDER=DESCENDING INPUTS_CATEGORY_ORDER=DESCENDING 
    MAX_ITERATIONS=100 CONFIDENCE_LEVEL=95 DF_METHOD=RESIDUAL COVB=ROBUST
  /EMMEANS_OPTIONS SCALE=ORIGINAL PADJUST=LSD.


**An Example Experimental Design
**Model 4.1: Table 5.34  (ch5data2.sav)

*Generalized Linear Mixed Models. 
GENLINMIXED
  /DATA_STRUCTURE SUBJECTS=id REPEATED_MEASURES=time COVARIANCE_TYPE=IDENTITY
  /FIELDS TARGET=readprof TRIALS=NONE OFFSET=NONE
  /TARGET_OPTIONS DISTRIBUTION=BINOMIAL LINK=LOGIT
  /FIXED  EFFECTS=time treatment treatment*time USE_INTERCEPT=TRUE
  /RANDOM USE_INTERCEPT=TRUE SUBJECTS=id COVARIANCE_TYPE=VARIANCE_COMPONENTS 
  /BUILD_OPTIONS TARGET_CATEGORY_ORDER=DESCENDING INPUTS_CATEGORY_ORDER=DESCENDING 
    MAX_ITERATIONS=100 CONFIDENCE_LEVEL=95 DF_METHOD=RESIDUAL COVB=ROBUST
  /EMMEANS_OPTIONS SCALE=ORIGINAL PADJUST=LSD.


**Table 5.34  Generalized Estimating Equations (GEE) Fixed Effects Model  (ch5data2.sav)

* Generalized Estimating Equations

GENLIN readprof (REFERENCE=FIRST) WITH treatment time
  /MODEL time treatment treatment*time INTERCEPT=YES
 DISTRIBUTION=BINOMIAL LINK=LOGIT
  /CRITERIA METHOD=FISHER(1) SCALE=1 MAXITERATIONS=100 MAXSTEPHALVING=5 PCONVERGE=1E-006(ABSOLUTE) 
    SINGULAR=1E-012 ANALYSISTYPE=3(WALD) CILEVEL=95 LIKELIHOOD=FULL
  /REPEATED SUBJECT=id WITHINSUBJECT=time SORT=YES CORRTYPE= INDEPENDENT ADJUSTCORR=YES COVB=ROBUST 
    MAXITERATIONS=100 PCONVERGE=1e-006(ABSOLUTE) UPDATECORR=1
  /MISSING CLASSMISSING=EXCLUDE
  /PRINT CPS DESCRIPTIVES MODELINFO FIT SUMMARY SOLUTION (EXPONENTIATED).

