**Chapter 6: Two-Level Models with Multinomial and Ordinal Outcomes (ch6data1.sav, ch6data2.sav)

**Defining a Preliminary Single-Level Model 
**Model 1.1: Table 6.3 (ch6data1.sav)

*Generalized Linear Mixed Models. 
GENLINMIXED
  /DATA_STRUCTURE SUBJECTS=schcode
  /FIELDS TARGET=plans TRIALS=NONE OFFSET=NONE
  /TARGET_OPTIONS REFERENCE=2 DISTRIBUTION=MULTINOMIAL LINK=LOGIT
  /FIXED  EFFECTS=gmgpa lowses male USE_INTERCEPT=TRUE
  /BUILD_OPTIONS TARGET_CATEGORY_ORDER=ASCENDING INPUTS_CATEGORY_ORDER=ASCENDING MAX_ITERATIONS=100 
    CONFIDENCE_LEVEL=95 DF_METHOD=RESIDUAL COVB=ROBUST
  /EMMEANS_OPTIONS SCALE=ORIGINAL PADJUST=LSD.

**Unconditional Two-Level Model
**Model 2.1: Tables 6.4, 6.5, 6.7  (ch6data1.sav)

*Generalized Linear Mixed Models. 
GENLINMIXED
  /DATA_STRUCTURE SUBJECTS=schcode
  /FIELDS TARGET=plans TRIALS=NONE OFFSET=NONE
  /TARGET_OPTIONS REFERENCE=2 DISTRIBUTION=MULTINOMIAL LINK=LOGIT
  /FIXED USE_INTERCEPT=TRUE
  /RANDOM USE_INTERCEPT=TRUE SUBJECTS=schcode COVARIANCE_TYPE=VARIANCE_COMPONENTS 
  /BUILD_OPTIONS TARGET_CATEGORY_ORDER=ASCENDING INPUTS_CATEGORY_ORDER=ASCENDING MAX_ITERATIONS=100 
    CONFIDENCE_LEVEL=95 DF_METHOD=RESIDUAL COVB=ROBUST
  /EMMEANS_OPTIONS SCALE=ORIGINAL PADJUST=LSD.

**Level-1 Model
**Model 2.2: Tables 6.7, 6.9 (ch6data1.sav)

*Generalized Linear Mixed Models. 
GENLINMIXED
  /DATA_STRUCTURE SUBJECTS=schcode
  /FIELDS TARGET=plans TRIALS=NONE OFFSET=NONE
  /TARGET_OPTIONS REFERENCE=2 DISTRIBUTION=MULTINOMIAL LINK=LOGIT
  /FIXED  EFFECTS=gmgpa lowses male USE_INTERCEPT=TRUE
  /RANDOM USE_INTERCEPT=TRUE SUBJECTS=schcode COVARIANCE_TYPE=VARIANCE_COMPONENTS 
  /BUILD_OPTIONS TARGET_CATEGORY_ORDER=ASCENDING INPUTS_CATEGORY_ORDER=ASCENDING MAX_ITERATIONS=100 
    CONFIDENCE_LEVEL=95 DF_METHOD=RESIDUAL COVB=ROBUST
  /EMMEANS_OPTIONS SCALE=ORIGINAL PADJUST=LSD.


**Adding School-Level Predictors
**Model 2.3: Tables 6.10, 6.11  (ch6data1.sav)

*Generalized Linear Mixed Models. 
GENLINMIXED
  /DATA_STRUCTURE SUBJECTS=schcode
  /FIELDS TARGET=plans TRIALS=NONE OFFSET=NONE
  /TARGET_OPTIONS REFERENCE=2 DISTRIBUTION=MULTINOMIAL LINK=LOGIT
  /FIXED  EFFECTS=gmacadpress gmlicense gmperlowses gmgpa lowses male USE_INTERCEPT=TRUE
  /RANDOM USE_INTERCEPT=TRUE SUBJECTS=schcode COVARIANCE_TYPE=VARIANCE_COMPONENTS 
  /BUILD_OPTIONS TARGET_CATEGORY_ORDER=ASCENDING INPUTS_CATEGORY_ORDER=ASCENDING MAX_ITERATIONS=100 
    CONFIDENCE_LEVEL=95 DF_METHOD=RESIDUAL COVB=ROBUST
  /EMMEANS_OPTIONS SCALE=ORIGINAL PADJUST=LSD.

 
**Investigating a Random Slope
**Model 2.4: Table 6.12  (ch6data1.sav)

*Generalized Linear Mixed Models. 
GENLINMIXED
  /DATA_STRUCTURE SUBJECTS=schcode
  /FIELDS TARGET=plans TRIALS=NONE OFFSET=NONE
  /TARGET_OPTIONS REFERENCE=2 DISTRIBUTION=MULTINOMIAL LINK=LOGIT
  /FIXED  EFFECTS=gmacadpress gmlicense gmperlowses gmgpa lowses male USE_INTERCEPT=TRUE
  /RANDOM EFFECTS=gmgpa USE_INTERCEPT=TRUE SUBJECTS=schcode COVARIANCE_TYPE=VARIANCE_COMPONENTS 
  /BUILD_OPTIONS TARGET_CATEGORY_ORDER=ASCENDING INPUTS_CATEGORY_ORDER=ASCENDING MAX_ITERATIONS=100 
    CONFIDENCE_LEVEL=95 DF_METHOD=RESIDUAL COVB=ROBUST
  /EMMEANS_OPTIONS SCALE=ORIGINAL PADJUST=LSD.
 

**Preliminary Analysis
**Model 3.1 (persistcat1): Table 6.18  (ch6data2.sav)

* Generalized Linear Models.
GENLIN persistcat1 (REFERENCE=FIRST) WITH zses hiabsent zabsent zqual zenroll zcomp
  /MODEL zses hiabsent zabsent zqual zenroll zcomp INTERCEPT=YES
 DISTRIBUTION=BINOMIAL LINK=LOGIT
  /CRITERIA METHOD=FISHER(1) SCALE=1 COVB=ROBUST MAXITERATIONS=100 MAXSTEPHALVING=5 
    PCONVERGE=1E-006(ABSOLUTE) SINGULAR=1E-012 ANALYSISTYPE=3(WALD) CILEVEL=95 CITYPE=WALD 
    LIKELIHOOD=FULL
  /MISSING CLASSMISSING=EXCLUDE
  /PRINT CPS DESCRIPTIVES MODELINFO FIT SUMMARY SOLUTION (EXPONENTIATED).


**Model 3.1 (persistcat1for2): Table 6.18  (ch6data2.sav)

* Generalized Linear Models.
GENLIN persistcat1for2 (REFERENCE=FIRST) WITH zses hiabsent zabsent zqual zenroll zcomp
  /MODEL zses hiabsent zabsent zqual zenroll zcomp INTERCEPT=YES
 DISTRIBUTION=BINOMIAL LINK=LOGIT
  /CRITERIA METHOD=FISHER(1) SCALE=1 COVB=ROBUST MAXITERATIONS=100 MAXSTEPHALVING=5 
    PCONVERGE=1E-006(ABSOLUTE) SINGULAR=1E-012 ANALYSISTYPE=3(WALD) CILEVEL=95 CITYPE=WALD 
    LIKELIHOOD=FULL
  /MISSING CLASSMISSING=EXCLUDE
  /PRINT CPS DESCRIPTIVES MODELINFO FIT SUMMARY SOLUTION (EXPONENTIATED).
 

**Adding Student Background Predictors
**Model 3.2: Table 6.21  (ch6data2.sav)

* Generalized Linear Models.
GENLIN persist3 (ORDER=ASCENDING) WITH zses hiabsent
  /MODEL zses hiabsent 
 DISTRIBUTION=MULTINOMIAL LINK=CUMLOGIT
  /CRITERIA METHOD=FISHER(1) SCALE=1 COVB=ROBUST MAXITERATIONS=100 MAXSTEPHALVING=5 
    PCONVERGE=1E-006(ABSOLUTE) SINGULAR=1E-012 ANALYSISTYPE=3(WALD) CILEVEL=95 CITYPE=WALD 
    LIKELIHOOD=FULL
  /MISSING CLASSMISSING=EXCLUDE
  /PRINT CPS DESCRIPTIVES MODELINFO FIT SUMMARY SOLUTION (EXPONENTIATED).


**Testing an Interaction 
**Model 3.3: Tables 6.22, 6.33  (ch6data2.sav)

* Generalized Linear Models.
GENLIN persist3 (ORDER=ASCENDING) WITH zses hiabsent
  /MODEL zses hiabsent zses*hiabsent 
 DISTRIBUTION=MULTINOMIAL LINK=CUMLOGIT
  /CRITERIA METHOD=FISHER(1) SCALE=1 COVB=ROBUST MAXITERATIONS=100 MAXSTEPHALVING=5 
    PCONVERGE=1E-006(ABSOLUTE) SINGULAR=1E-012 ANALYSISTYPE=3(WALD) CILEVEL=95 CITYPE=WALD 
    LIKELIHOOD=FULL
  /MISSING CLASSMISSING=EXCLUDE
  /PRINT CPS DESCRIPTIVES MODELINFO FIT SUMMARY SOLUTION (EXPONENTIATED).

**Multilevel Ordinal Unconditional Model 
**Table 4.1: Tables 6.24, 6.25, 6.26  (ch6data2.sav)

*Generalized Linear Mixed Models. 
GENLINMIXED
  /DATA_STRUCTURE SUBJECTS=schcode
  /FIELDS TARGET=persist3 TRIALS=NONE OFFSET=NONE
  /TARGET_OPTIONS REFERENCE=2 DISTRIBUTION=MULTINOMIAL LINK=LOGIT
  /FIXED USE_INTERCEPT=TRUE
  /RANDOM USE_INTERCEPT=TRUE SUBJECTS=schcode COVARIANCE_TYPE=VARIANCE_COMPONENTS 
  /BUILD_OPTIONS TARGET_CATEGORY_ORDER=ASCENDING INPUTS_CATEGORY_ORDER=ASCENDING MAX_ITERATIONS=100 
    CONFIDENCE_LEVEL=95 DF_METHOD=RESIDUAL COVB=ROBUST
  /EMMEANS_OPTIONS SCALE=ORIGINAL PADJUST=LSD.

**Within-School Predictor
**Model 4.2: Tables 6.28, 6.29, 6.30 (ch6data2.sav)

*Generalized Linear Mixed Models. 
GENLINMIXED
  /DATA_STRUCTURE SUBJECTS=schcode
  /FIELDS TARGET=persist3 TRIALS=NONE OFFSET=NONE
  /TARGET_OPTIONS REFERENCE=2 DISTRIBUTION=MULTINOMIAL LINK=LOGIT
  /FIXED  EFFECTS=zses hiabsent USE_INTERCEPT=TRUE
  /RANDOM USE_INTERCEPT=TRUE SUBJECTS=schcode COVARIANCE_TYPE=VARIANCE_COMPONENTS 
  /BUILD_OPTIONS TARGET_CATEGORY_ORDER=ASCENDING INPUTS_CATEGORY_ORDER=ASCENDING MAX_ITERATIONS=100 
    CONFIDENCE_LEVEL=95 DF_METHOD=RESIDUAL COVB=ROBUST
  /EMMEANS_OPTIONS SCALE=ORIGINAL PADJUST=LSD.

**Adding the School-level Predictors
**Model 4.3: Tables 6.31, 6.32, 6.33  (ch6data2.sav)

*Generalized Linear Mixed Models. 
GENLINMIXED
  /DATA_STRUCTURE SUBJECTS=schcode
  /FIELDS TARGET=persist3 TRIALS=NONE OFFSET=NONE
  /TARGET_OPTIONS REFERENCE=2 DISTRIBUTION=MULTINOMIAL LINK=LOGIT
  /FIXED  EFFECTS=zqual zabsent zenroll zcomp zses hiabsent USE_INTERCEPT=TRUE
  /RANDOM USE_INTERCEPT=TRUE SUBJECTS=schcode COVARIANCE_TYPE=VARIANCE_COMPONENTS 
  /BUILD_OPTIONS TARGET_CATEGORY_ORDER=ASCENDING INPUTS_CATEGORY_ORDER=ASCENDING MAX_ITERATIONS=100 
    CONFIDENCE_LEVEL=95 DF_METHOD=RESIDUAL COVB=ROBUST
  /EMMEANS_OPTIONS SCALE=ORIGINAL PADJUST=LSD.

**Table 6.34; Alternative Model 4.3: Fixed Effects with Complementary Log-Log  (ch6data2.sav)

*Generalized Linear Mixed Models. 
GENLINMIXED
  /DATA_STRUCTURE SUBJECTS=schcode
  /FIELDS TARGET=persist3 TRIALS=NONE OFFSET=NONE
  /TARGET_OPTIONS REFERENCE=2 DISTRIBUTION=MULTINOMIAL LINK=CLOGLOG
  /FIXED  EFFECTS=zqual zabsent zenroll zcomp zses hiabsent USE_INTERCEPT=TRUE
  /RANDOM USE_INTERCEPT=TRUE SUBJECTS=schcode COVARIANCE_TYPE=VARIANCE_COMPONENTS 
  /BUILD_OPTIONS TARGET_CATEGORY_ORDER=ASCENDING INPUTS_CATEGORY_ORDER=ASCENDING MAX_ITERATIONS=100 
    CONFIDENCE_LEVEL=95 DF_METHOD=RESIDUAL COVB=ROBUST
  /EMMEANS_OPTIONS SCALE=ORIGINAL PADJUST=LSD.

**Interpreting a Categorical Predictor
**Tables 6.35, 6.36 (ch6data2.sav)

*Generalized Linear Mixed Models. 
GENLINMIXED
  /DATA_STRUCTURE SUBJECTS=schcode
  /FIELDS TARGET=persist3 TRIALS=NONE OFFSET=NONE
  /TARGET_OPTIONS REFERENCE=2 DISTRIBUTION=MULTINOMIAL LINK=LOGIT
  /FIXED  EFFECTS=zqual zabsent zcomp enroll3 zses hiabsent USE_INTERCEPT=TRUE
  /RANDOM USE_INTERCEPT=TRUE SUBJECTS=schcode COVARIANCE_TYPE=VARIANCE_COMPONENTS 
  /BUILD_OPTIONS TARGET_CATEGORY_ORDER=ASCENDING INPUTS_CATEGORY_ORDER=DESCENDING 
    MAX_ITERATIONS=100 CONFIDENCE_LEVEL=95 DF_METHOD=RESIDUAL COVB=ROBUST
  /EMMEANS_OPTIONS SCALE=ORIGINAL PADJUST=LSD.

**Examining a Mediating Effect at Level 1
**Model 4.4: Table 6.37 (ch6data2.sav)

*Generalized Linear Mixed Models. 
GENLINMIXED
  /DATA_STRUCTURE SUBJECTS=schcode
  /FIELDS TARGET=persist3 TRIALS=NONE OFFSET=NONE
  /TARGET_OPTIONS REFERENCE=0 DISTRIBUTION=MULTINOMIAL LINK=LOGIT
  /FIXED  EFFECTS=zses USE_INTERCEPT=TRUE
  /RANDOM USE_INTERCEPT=TRUE SUBJECTS=schcode COVARIANCE_TYPE=VARIANCE_COMPONENTS 
  /BUILD_OPTIONS TARGET_CATEGORY_ORDER=ASCENDING INPUTS_CATEGORY_ORDER=ASCENDING MAX_ITERATIONS=100 
    CONFIDENCE_LEVEL=95 DF_METHOD=RESIDUAL COVB=ROBUST
  /EMMEANS_OPTIONS SCALE=ORIGINAL PADJUST=LSD.

**Model 4.5: Table 6.38 (ch6data2.sav)

*Generalized Linear Mixed Models. 
GENLINMIXED
  /DATA_STRUCTURE SUBJECTS=schcode
  /FIELDS TARGET=persist3 TRIALS=NONE OFFSET=NONE
  /TARGET_OPTIONS REFERENCE=2 DISTRIBUTION=MULTINOMIAL LINK=LOGIT
  /FIXED  EFFECTS=zses zgpa USE_INTERCEPT=TRUE
  /RANDOM USE_INTERCEPT=TRUE SUBJECTS=schcode COVARIANCE_TYPE=IDENTITY 
  /BUILD_OPTIONS TARGET_CATEGORY_ORDER=ASCENDING INPUTS_CATEGORY_ORDER=ASCENDING MAX_ITERATIONS=100 
    CONFIDENCE_LEVEL=95 DF_METHOD=RESIDUAL COVB=ROBUST
  /EMMEANS_OPTIONS SCALE=ORIGINAL PADJUST=LSD.
